]> git.ipfire.org Git - ipfire-2.x.git/blob - make.sh
Ein Fix fuer das Hochladen der Dateien auf unseren Source-FTP-Server.
[ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2007 IPFire-Team <info@ipfire.org>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.0beta1" # Version number
28 SLOGAN="www.ipfire.org" # Software slogan
29 CONFIG_ROOT=/var/ipfire # Configuration rootdir
30 NICE=10 # Nice level
31 MAX_RETRIES=1 # prefetch/check loop
32 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33 MACHINE=`uname -m`
34 SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
36 IPFVER="full" # Which versions should be compiled? (full|devel)
37
38 # Set an information about the build number
39 if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41 fi
42
43 # Debian specific settings
44 if [ ! -e /etc/debian_version ]; then
45 FULLPATH=`which $0`
46 else
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
53 fi
54
55 PWD=`pwd`
56 BASENAME=`basename $0`
57 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58 LOGFILE=$BASEDIR/log/_build.preparation.log
59 export BASEDIR LOGFILE
60 DIR_CHK=$BASEDIR/cache/check
61 mkdir $BASEDIR/log/ 2>/dev/null
62
63 # Include funtions
64 . tools/make-functions
65
66 if [ -f .config ]; then
67 . .config
68 else
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
76 fi
77
78 prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
89 exiterror "Not running BASH shell."
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
109 beautify message FAIL
110 exiterror "Failed to set correct nice level"
111 else
112 beautify message DONE
113 fi
114
115
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
122 if [ `id -u` != 0 ]; then
123 beautify message FAIL
124 exiterror "Not building as root"
125 else
126 beautify message DONE
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
138 if (( 2048000 > $BASE_ASPACE )); then
139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
141 beautify message FAIL
142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
143 fi
144 else
145 beautify message DONE
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
164 ln -s $BASEDIR/build/tools /
165 fi
166 if [ ! -h /tools ]; then
167 exiterror "Could not create /tools symbolic link."
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
173 MAKETUNING="-j6"
174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
185
186 # Make all sources and proc available under lfs build
187 mount --bind /dev $BASEDIR/build/dev
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
202 # This is a temporary hack!!!
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
206
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213 }
214
215 buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
227 lfsmake1 cleanup-toolchain PASS=1
228 lfsmake1 tcl
229 lfsmake1 expect
230 lfsmake1 dejagnu
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
233 lfsmake1 ncurses
234 lfsmake1 bash
235 lfsmake1 bzip2
236 lfsmake1 coreutils
237 lfsmake1 diffutils
238 lfsmake1 findutils
239 lfsmake1 gawk
240 lfsmake1 gettext
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
245 lfsmake1 patch
246 lfsmake1 perl
247 lfsmake1 sed
248 lfsmake1 tar
249 lfsmake1 texinfo
250 lfsmake1 util-linux
251 lfsmake1 cleanup-toolchain PASS=2
252 export PATH=$ORG_PATH
253 }
254
255 buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
258 lfsmake2 stage2
259 lfsmake2 linux-libc-header
260 lfsmake2 man-pages
261 lfsmake2 glibc
262 lfsmake2 cleanup-toolchain PASS=3
263 lfsmake2 binutils
264 lfsmake2 gcc
265 lfsmake2 berkeley
266 lfsmake2 coreutils
267 lfsmake2 iana-etc
268 lfsmake2 m4
269 lfsmake2 bison
270 lfsmake2 ncurses
271 lfsmake2 procps
272 lfsmake2 sed
273 lfsmake2 libtool
274 lfsmake2 perl
275 lfsmake2 readline
276 lfsmake2 zlib
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
280 lfsmake2 bzip2
281 lfsmake2 diffutils
282 lfsmake2 e2fsprogs
283 lfsmake2 ed
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
287 lfsmake2 gawk
288 lfsmake2 gettext
289 lfsmake2 grep
290 lfsmake2 groff
291 lfsmake2 gzip
292 lfsmake2 inetutils
293 lfsmake2 iproute2
294 lfsmake2 kbd
295 lfsmake2 less
296 lfsmake2 libaal
297 lfsmake2 make
298 lfsmake2 man
299 lfsmake2 mktemp
300 lfsmake2 modutils
301 lfsmake2 mtd
302 lfsmake2 net-tools
303 lfsmake2 patch
304 lfsmake2 psmisc
305 lfsmake2 reiser4progs
306 lfsmake2 shadow
307 lfsmake2 sysklogd
308 lfsmake2 sysvinit
309 lfsmake2 tar
310 lfsmake2 texinfo
311 lfsmake2 udev
312 lfsmake2 util-linux
313 lfsmake2 vim
314 lfsmake2 grub
315 }
316
317 buildipfire() {
318 LOGFILE="$BASEDIR/log/_build.ipfire.log"
319 export LOGFILE
320 ipfiremake configroot
321 ipfiremake dhcp
322 ipfiremake dhcpcd
323 ipfiremake libusb
324 ipfiremake libpcap
325 ipfiremake linux-atm
326 ipfiremake ppp
327 ipfiremake rp-pppoe
328 ipfiremake unzip
329 ipfiremake linux SMP=1
330 ipfiremake ipp2p SMP=1
331 ipfiremake r8169 SMP=1
332 ipfiremake zaptel SMP=1
333 ipfiremake linux
334 ipfiremake ipp2p
335 ipfiremake r8169
336 ipfiremake zaptel
337 ipfiremake pkg-config
338 ipfiremake cpio
339 ipfiremake klibc
340 ipfiremake mkinitcpio
341 ipfiremake udev KLIBC=1
342 ipfiremake expat
343 ipfiremake gdbm
344 ipfiremake gmp
345 ipfiremake pam
346 ipfiremake openssl
347 ipfiremake curl
348 ipfiremake python
349 ipfiremake libnet
350 ipfiremake libjpeg
351 ipfiremake libpng
352 ipfiremake libtiff
353 ipfiremake libart
354 ipfiremake freetype
355 ipfiremake gd
356 ipfiremake popt
357 ipfiremake pcre
358 ipfiremake slang
359 ipfiremake newt
360 ipfiremake libcap
361 ipfiremake pciutils
362 ipfiremake usbutils
363 ipfiremake libxml2
364 ipfiremake libxslt
365 ipfiremake BerkeleyDB
366 ipfiremake mysql
367 ipfiremake cyrus-sasl
368 ipfiremake openldap
369 ipfiremake apache2
370 ipfiremake php
371 ipfiremake apache2 PASS=C
372 ipfiremake arping
373 ipfiremake beep
374 ipfiremake bind
375 ipfiremake cdrtools
376 ipfiremake dnsmasq
377 ipfiremake dosfstools
378 ipfiremake squashfstools
379 ipfiremake reiserfsprogs
380 ipfiremake sysfsutils
381 ipfiremake fuse
382 ipfiremake ntfs-3g
383 ipfiremake ethtool
384 ipfiremake ez-ipupdate
385 ipfiremake fcron
386 ipfiremake perl-GD
387 ipfiremake GD-Graph
388 ipfiremake GD-TextUtil
389 ipfiremake gnupg
390 ipfiremake hdparm
391 ipfiremake mtools
392 ipfiremake initscripts
393 ipfiremake whatmask
394 ipfiremake iptables
395 ipfiremake libupnp
396 ipfiremake ipp2p IPT=1
397 ipfiremake moblock
398 ipfiremake linux-igd
399 ipfiremake ipac-ng
400 ipfiremake ipaddr
401 ipfiremake iptstate
402 ipfiremake iputils
403 ipfiremake l7-protocols
404 ipfiremake mISDN
405 ipfiremake hwdata
406 ipfiremake kudzu
407 ipfiremake logrotate
408 ipfiremake logwatch
409 ipfiremake misc-progs
410 ipfiremake nano
411 ipfiremake nasm
412 ipfiremake URI
413 ipfiremake HTML-Tagset
414 ipfiremake HTML-Parser
415 ipfiremake Compress-Zlib
416 ipfiremake Digest
417 ipfiremake Digest-SHA1
418 ipfiremake Digest-HMAC
419 ipfiremake libwww-perl
420 ipfiremake Net-DNS
421 ipfiremake Net-IPv4Addr
422 ipfiremake Net_SSLeay
423 ipfiremake IO-Stringy
424 ipfiremake Unix-Syslog
425 ipfiremake Mail-Tools
426 ipfiremake MIME-Tools
427 ipfiremake Net-Server
428 ipfiremake Convert-TNEF
429 ipfiremake Convert-UUlib
430 ipfiremake Archive-Tar
431 ipfiremake Archive-Zip
432 ipfiremake Text-Tabs+Wrap
433 ipfiremake Locale-Country
434 ipfiremake XML-Parser
435 ipfiremake glib
436 ipfiremake GeoIP
437 ipfiremake fwhits
438 ipfiremake noip_updater
439 ipfiremake ntp
440 ipfiremake openssh
441 ipfiremake openswan
442 ipfiremake rrdtool
443 ipfiremake setserial
444 ipfiremake setup
445 ipfiremake snort
446 ipfiremake oinkmaster
447 ipfiremake squid
448 ipfiremake squid-graph
449 ipfiremake squidguard
450 ipfiremake calamaris
451 ipfiremake tcpdump
452 ipfiremake traceroute
453 ipfiremake vlan
454 ipfiremake wireless
455 ipfiremake libsafe
456 ipfiremake pakfire
457 ipfiremake java
458 ipfiremake spandsp
459 ipfiremake lzo
460 ipfiremake openvpn
461 ipfiremake pammysql
462 ipfiremake cups
463 ipfiremake ghostscript
464 ipfiremake foomatic
465 ipfiremake samba
466 ipfiremake sudo
467 ipfiremake mc
468 ipfiremake wget
469 ipfiremake bridge-utils
470 ipfiremake screen
471 ipfiremake hddtemp
472 ipfiremake smartmontools
473 ipfiremake htop
474 ipfiremake postfix
475 ipfiremake fetchmail
476 ipfiremake cyrusimap
477 ipfiremake webcyradm
478 ipfiremake mailx
479 ipfiremake clamav
480 ipfiremake spamassassin
481 ipfiremake amavisd
482 ipfiremake alsa
483 ipfiremake mpg123
484 ipfiremake mpfire
485 ipfiremake guardian
486 ipfiremake libid3tag
487 ipfiremake libmad
488 ipfiremake libogg
489 ipfiremake libvorbis
490 ipfiremake lame
491 ipfiremake sox
492 ipfiremake libshout
493 ipfiremake icecast
494 ipfiremake icegenerator
495 ipfiremake mpd
496 ipfiremake mpc
497 ipfiremake xvid
498 ipfiremake libmpeg2
499 #ipfiremake ffmpeg
500 ipfiremake videolan
501 ipfiremake libpri
502 ipfiremake stund
503 ipfiremake asterisk
504 ipfiremake backup
505 ipfiremake gnump3d
506 ipfiremake libsigc++
507 ipfiremake applejuice
508 ipfiremake ocaml
509 ipfiremake mldonkey
510 ipfiremake libtorrent
511 ipfiremake rtorrent
512 ipfiremake ipfireseeder
513 ipfiremake rsync
514 ipfiremake tcpwrapper
515 ipfiremake portmap
516 ipfiremake nfs
517 ipfiremake nmap
518 ipfiremake mbmon
519 ipfiremake iftop
520 ipfiremake ncftp
521 ipfiremake cftp
522 ipfiremake etherwake
523 ipfiremake ethereal
524 ipfiremake tftp-hpa
525 ipfiremake bwm-ng
526 ipfiremake tripwire
527 ipfiremake sysstat
528 ipfiremake vsftpd
529 ipfiremake which
530 ipfiremake lsof
531 }
532
533 buildinstaller() {
534 # Run installer scripts one by one
535 LOGFILE="$BASEDIR/log/_build.installer.log"
536 export LOGFILE
537 ipfiremake syslinux
538 ipfiremake as86
539 ipfiremake mbr
540 ipfiremake memtest
541 installmake linux-libc-header
542 installmake binutils
543 ipfiremake uClibc PASS=1
544 ipfiremake gcc INST=1
545 installmake uClibc PASS=2
546 installmake gcc INST=2
547 installmake uClibc PASS=3
548 installmake busybox
549 installmake udev
550 installmake slang
551 installmake newt
552 installmake gettext
553 installmake kbd
554 installmake popt
555 installmake sysvinit
556 installmake misc-progs
557 installmake libaal
558 installmake reiser4progs
559 installmake reiserfsprogs
560 installmake sysfsutils
561 installmake util-linux
562 installmake pciutils
563 installmake zlib
564 installmake mtd
565 installmake wget
566 installmake hwdata
567 installmake kudzu
568 installmake installer
569 installmake initrd
570 }
571
572 buildpackages() {
573 LOGFILE="$BASEDIR/log/_build.packages.log"
574 export LOGFILE
575 echo "... see detailed log in _build.*.log files" >> $LOGFILE
576
577 installmake strip
578
579 # Generating list of packages used
580 echo -n "Generating packages list from logs" | tee -a $LOGFILE
581 rm -f $BASEDIR/doc/packages-list
582 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
583 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
584 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
585 fi
586 done
587 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
588 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
589 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
590 rm -f $BASEDIR/doc/packages-list
591 # packages-list.txt is ready to be displayed for wiki page
592 beautify message DONE
593
594 # Create images for install
595 ipfiremake cdrom ED=full
596
597 # Check if there is a loop device for building in virtual environments
598 if [ -e /dev/loop/0 ] || [ -e /dev/loop0 ]; then
599 ipfiremake usb-stick
600 fi
601 ipfiremake pxe
602 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz} $BASEDIR >> $LOGFILE 2>&1
603
604 ipfirepackages
605
606 # Cleanup
607 stdumount
608 rm -rf $BASEDIR/build/tmp/*
609
610 # Generating total list of files
611 echo -n "Generating files list from logs" | tee -a $LOGFILE
612 rm -f $BASEDIR/log/FILES
613 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
614 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
615 echo "##" >>$BASEDIR/log/FILES
616 echo "## `basename $i`" >>$BASEDIR/log/FILES
617 echo "##" >>$BASEDIR/log/FILES
618 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
619 fi
620 done
621 beautify message DONE
622
623 cd $PWD
624 }
625
626 ipfirepackages() {
627 ipfiremake core-updates
628 for i in $(ls -1 $BASEDIR/config/rootfiles/packages); do
629 [ -e $BASEDIR/lfs/$i ] && ipfiredist $i
630 done
631 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
632 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
633 rm -rf $BASEDIR/build/install/packages/*
634 }
635
636 # See what we're supposed to do
637 case "$1" in
638 build)
639 clear
640 BUILDMACHINE=`uname -m`
641 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
642 #only restore on a clean disk
643 if [ ! -f log/cleanup-toolchain-2-tools ]; then
644 if [ ! -n "$PACKAGE" ]; then
645 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
646 prepareenv
647 buildtoolchain
648 else
649 PACKAGENAME=${PACKAGE%.tar.gz}
650 beautify build_stage "Packaged toolchain compilation"
651 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
652 tar zxf $PACKAGE
653 prepareenv
654 else
655 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
656 fi
657 fi
658 else
659 echo -n "Using installed toolchain" | tee -a $LOGFILE
660 beautify message SKIP
661 prepareenv
662 fi
663
664 beautify build_start
665 beautify build_stage "Building LFS"
666 buildbase
667
668 beautify build_stage "Building IPFire"
669 buildipfire
670
671 # Setzen des IPFire Builds
672 if [ "$FIREBUILD" ]; then
673 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
674 else
675 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
676 fi
677
678 beautify build_stage "Building installer"
679 buildinstaller
680
681 beautify build_stage "Building packages"
682 buildpackages
683 beautify build_end
684 ;;
685 shell)
686 # enter a shell inside LFS chroot
687 # may be used to changed kernel settings
688 prepareenv
689 entershell
690 ;;
691 changelog)
692 echo -n "Loading new Changelog from SVN: "
693 svn log http://svn.ipfire.org/svn/ipfire > doc/ChangeLog
694 beautify message DONE
695 ;;
696 clean)
697 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
698 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
699 $LOSETUP -d $i 2>/dev/null
700 done
701 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
702 umount $i
703 done
704 stdumount
705 for i in `seq 0 7`; do
706 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
707 umount /dev/loop${i} 2>/dev/null;
708 losetup -d /dev/loop${i} 2>/dev/null;
709 fi;
710 done
711 rm -rf $BASEDIR/build
712 rm -rf $BASEDIR/cdrom
713 rm -rf $BASEDIR/packages
714 rm -rf $BASEDIR/log
715 if [ -h /tools ]; then
716 rm -f /tools
717 fi
718 beautify message DONE
719 ;;
720 downloadsrc)
721 if [ ! -d $BASEDIR/cache ]; then
722 mkdir $BASEDIR/cache
723 fi
724 mkdir -p $BASEDIR/log
725 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
726 FINISHED=0
727 cd $BASEDIR/lfs
728 for c in `seq $MAX_RETRIES`; do
729 if (( FINISHED==1 )); then
730 break
731 fi
732 FINISHED=1
733 cd $BASEDIR/lfs
734 for i in *; do
735 if [ -f "$i" -a "$i" != "Config" ]; then
736 echo -ne "Loading $i"
737 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
738 if [ $? -ne 0 ]; then
739 beautify message FAIL
740 FINISHED=0
741 else
742 if [ $c -eq 1 ]; then
743 beautify message DONE
744 fi
745 fi
746 fi
747 done
748 done
749 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
750 ERROR=0
751 for i in *; do
752 if [ -f "$i" -a "$i" != "Config" ]; then
753 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
754 if [ $? -ne 0 ]; then
755 echo -ne "MD5 difference in lfs/$i"
756 beautify message FAIL
757 ERROR=1
758 fi
759 fi
760 done
761 if [ $ERROR -eq 0 ]; then
762 echo -ne "${BOLD}all files md5sum match${NORMAL}"
763 beautify message DONE
764 else
765 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
766 beautify message FAIL
767 fi
768 cd - >/dev/null 2>&1
769 ;;
770 toolchain)
771 clear
772 prepareenv
773 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
774 buildtoolchain
775 BUILDMACHINE=`uname -m`
776 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
777 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
778 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
779 build/{bin,etc,usr/bin,usr/local} \
780 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
781 log >> $LOGFILE
782 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
783 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
784 stdumount
785 ;;
786 gettoolchain)
787 BUILDMACHINE=`uname -m`
788 # arbitrary name to be updated in case of new toolchain package upload
789 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
790 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
791 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
792 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
793 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
794 cd $BASEDIR/cache/toolchains
795 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
796 if [ $? -ne 0 ]; then
797 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
798 else
799 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
800 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
801 else
802 exiterror "$PACKAGE.md5 did not match, check downloaded package"
803 fi
804 fi
805 else
806 echo "Toolchain is already downloaded. Exiting..."
807 fi
808 ;;
809 othersrc)
810 prepareenv
811 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
812 chroot $LFS /tools/bin/env -i HOME=/root \
813 TERM=$TERM PS1='\u:\w\$ ' \
814 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
815 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
816 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
817 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
818 if [ $? -eq "0" ]; then
819 beautify message DONE
820 else
821 beautify message FAIL
822 fi
823 stdumount
824 ;;
825 svn)
826 case "$2" in
827 update|up)
828 # clear
829 echo -ne "Loading the latest source files...\n"
830 if [ $3 ]; then
831 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
832 else
833 svn update | tee -a $PWD/log/_build.svn.update.log
834 fi
835 if [ $? -eq "0" ]; then
836 beautify message DONE
837 else
838 beautify message FAIL
839 exit 1
840 fi
841 echo -ne "Writing the svn-info to a file"
842 svn info > $PWD/svn_status
843 if [ $? -eq "0" ]; then
844 beautify message DONE
845 else
846 beautify message FAIL
847 exit 1
848 fi
849 chmod 755 $0
850 exit 0
851 ;;
852 commit|ci)
853 clear
854 if [ -f /usr/bin/mcedit ]; then
855 export EDITOR=/usr/bin/mcedit
856 fi
857 if [ -f /usr/bin/nano ]; then
858 export EDITOR=/usr/bin/nano
859 fi
860 echo -ne "Selecting editor $EDITOR..."
861 beautify message DONE
862 if [ -e /sbin/yast ]; then
863 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
864 $0 changelog
865 fi
866 fi
867 update_langs
868 svn commit
869 $0 svn up
870 if [ -n "$FTP_CACHE_URL" ]; then
871 $0 uploadsrc
872 fi
873 ;;
874 dist)
875 if [ $3 ]; then
876 SVN_REVISION=$3
877 fi
878 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
879 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
880 exit 0
881 fi
882 echo -en "REV $SVN_REVISION: Downloading..."
883 svn export http://svn.ipfire.org/svn/ipfire/trunk ipfire-source/ --force > /dev/null
884 svn log http://svn.ipfire.org/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
885 #svn info http://svn.ipfire.org/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
886 evaluate 1
887
888 echo -en "REV $SVN_REVISION: Compressing files..."
889 if [ -e ipfire-source/trunk/make.sh ]; then
890 chmod 755 ipfire-source/trunk/make.sh
891 fi
892 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
893 evaluate 1
894 echo -en "REV $SVN_REVISION: Cleaning up..."
895 rm ipfire-source/ -r
896 evaluate 1
897 ;;
898 diff|di)
899 update_langs
900 echo -ne "Make a local diff to last svn revision"
901 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
902 evaluate 1
903 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
904 svn status
905 ;;
906 esac
907 ;;
908 uploadsrc)
909 PWD=`pwd`
910 cd $BASEDIR/cache/
911 echo -e "Uploading cache to ftp server:"
912 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL/$FTP_CACHE_PATH/ > /tmp/ftplist
913 for i in *; do
914 if [ "$(basename $i)" == "toolchains" ]; then continue; fi
915 grep -q $(basename $i) /tmp/ftplist
916 if [ "$?" -ne "0" ]; then
917 echo -ne "$(basename $i)"
918 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $(basename $i)
919 if [ "$?" -ne "0" ]; then
920 beautify message FAIL
921 fi
922 fi
923 done
924 rm -f /tmp/ftplist
925 cd $PWD
926 exit 0
927 ;;
928 upload)
929 FTP_ISO_PORT=`echo "$FTP_ISO_URL" | awk -F: '{ print $2 }'`
930 FTP_ISO_URL=`echo "$FTP_ISO_URL" | awk -F: '{ print $1 }'`
931 if [ -z $FTP_ISO_PORT ]; then
932 FTP_ISO_PORT=21
933 fi
934 cat <<EOF > .ftp-commands
935 mkdir -p $FTP_ISO_PATH$SVN_REVISION
936 mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
937 quit
938 EOF
939 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL < .ftp-commands
940 rm -f .ftp-commands
941
942 case "$2" in
943 iso)
944 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
945
946 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
947 for i in svn_status ipfire-source-r$SVN_REVISION.tar.gz ipfire-$VERSION.$MACHINE-full.iso ipfire-$VERSION.$MACHINE-full.iso.md5 ipfire-$VERSION.$MACHINE-devel.iso ipfire-$VERSION.$MACHINE-devel.iso.md5; do
948 if [ -e "$i" ]; then
949 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ $i
950 if [ "$?" -eq "0" ]; then
951 echo "The file with name $i was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
952 else
953 echo "There was an error while uploading the file $i to the ftp server."
954 exit 1
955 fi
956 fi
957 done
958 rm -f ipfire-$VERSION.$MACHINE-full.iso.md5
959 if [ "$3" = "--with-sources-cd" ]; then
960 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
961 fi
962 ;;
963 paks)
964 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
965 if [ "$?" -eq "0" ]; then
966 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
967 else
968 echo -e "There was an error while uploading the packages to the ftp server."
969 exit 1
970 fi
971 ;;
972 esac
973 ;;
974 batch)
975 if [ "$2" = "--background" ]; then
976 batch_script
977 exit $?
978 fi
979 if [ `screen -ls | grep -q ipfire` ]; then
980 echo "Build is already running, sorry!"
981 exit 1
982 else
983 if [ "$2" = "--rebuild" ]; then
984 export IPFIRE_REBUILD=1
985 echo "REBUILD!"
986 else
987 export IPFIRE_REBUILD=0
988 fi
989 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
990 screen -dmS ipfire $0 batch --background
991 evaluate 1
992 exit 0
993 fi
994 ;;
995 watch)
996 watch_screen
997 ;;
998 pxe)
999 case "$2" in
1000 start)
1001 start_tftpd
1002 ;;
1003 stop)
1004 stop_tftpd
1005 ;;
1006 reload|restart)
1007 reload_tftpd
1008 ;;
1009 esac
1010 exit 0
1011 ;;
1012 lang)
1013 update_langs
1014 ;;
1015 "")
1016 clear
1017 svn info
1018 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
1019 do
1020 case $name in
1021 "IPFIRE: Downloadsrc")
1022 $0 downloadsrc
1023 ;;
1024 "IPFIRE: Build (silent)")
1025 $0 build-silent
1026 ;;
1027 "IPFIRE: Watch Build")
1028 $0 watch
1029 ;;
1030 "IPFIRE: Batch")
1031 $0 batch
1032 ;;
1033 "IPFIRE: Clean")
1034 $0 clean
1035 ;;
1036 "SVN: Update")
1037 $0 svn update
1038 ;;
1039 "Help")
1040 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1041 cat doc/make.sh-usage
1042 ;;
1043 "LOG: Tail")
1044 tail -f log/_*
1045 ;;
1046 "Exit")
1047 break
1048 ;;
1049 esac
1050 done
1051 ;;
1052 config)
1053 make_config
1054 ;;
1055 *)
1056 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1057 cat doc/make.sh-usage
1058 ;;
1059 esac